<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2016 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
$accessControl = array(
    "Admin" => true
);
require_once "../../AccessControl.php";

/**
* @desc This function will enable or disable the ipencoding setting in the global.php file
*/
function toggleIPencoding() {
    global $ipencoding;

    $gfile  = "../../files/global.php";

    if (!file_exists($gfile)) {
    	return '{ "Status": "Error", "Message": "'. _GLOBAL_NOT_FOUND .'" }';
    }

    if (!is_writable($gfile)) {
    	return '{ "Status": "Error", "Message": "'. _GLOBAL_NOT_WRITABLE .'" }';
    }

    $s = file_get_contents($gfile);
    # check if we already have the setting
    if (isset($ipencoding)) {
        if ($ipencoding === true) { # Check if the var is a boolean and set true
            $s = str_replace("ipencoding=true","ipencoding=false",$s);
            $msg = _IP_ENDCODING_DISABLED;
        } else {
            $s = str_replace("ipencoding=false","ipencoding=true",$s);
            $msg = _IP_ENDCODING_ENABLED . "!";
        }
    } else {
        # if the setting was not present to begin with, we know we now have to enable it
        $s = str_replace("?>","\$ipencoding=true;\n?>",$s);
        $msg = _IP_ENDCODING_ENABLED . "!";
    }

    if (file_put_contents($gfile,$s)===false) {
        return '{ "Status": "Error", "Message": "'. _PROBLEM_WRITING_GLOBAL .'" }';
    } else {
        return '{ "Status": "Success", "Message": "'.$msg.'" }';
    }        
}


if (isset($_REQUEST["toggle_ipencode"])==1) {
    $res = toggleIPencoding();
    $msg = json_decode($res, true);
    if ($msg["Status"] == "Success") {
        include("../../files/global.php");
    } 
    echo $res;   
} else {

	# we are not setting the value, just requesting it
	if (@$ipencoding==true) {
        echo '{ "Status": "'. _ENABLED .'" }';
    } else {
        echo '{ "Status": "'. _DISABLED .'" }';
    }
}
?>